/*
** RopGadget - Version Release v2
** Jonathan Salwan - http://shell-storm.org - http://twitter.com/shell_storm
** 2011-03-11
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
*/

#ifndef	 _ROPgadget_linux8632_H_
#define	 _ROPgadget_linux8632_H_

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <elf.h>

/* colors */
#define BLUE        "\033[94m"
#define GREEN       "\033[92m"
#define YELLOW      "\033[93m"
#define RED         "\033[91m"
#define ENDC        "\033[0m"

#define MAGIC_ELF   "\x7F\x45\x4C\x46"
#define NB_GADGET   48

Elf32_Ehdr          *pElf_Header;
Elf32_Phdr          *pElf32_Phdr;
Elf32_Shdr          *pElf32_Shdr;

/* core */
typedef void   (*p_func)(unsigned char *, unsigned int, int *, Elf32_Addr);

void           syntax(char *);
void           display_data(unsigned char *, unsigned int);
void           search_gadgets(unsigned char *, unsigned int);
void           print_info_header(void);
unsigned char  *save_bin_data(char *, unsigned int);
int            check_elf_format(unsigned char *);
int            check_arch_supported(void);
void           no_elf_format(void);
void           no_arch_supported(void);
void           how_many_found(int *);

/* gadgets series */
/* gadget linux/x86-32bits */
void           gadget_linux8632_00(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_01(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_02(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_03(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_04(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_05(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_06(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_07(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_08(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_09(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_10(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_11(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_12(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_13(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_14(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_15(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_16(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_17(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_18(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_19(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_20(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_21(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_22(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_23(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_24(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_25(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_26(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_27(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_28(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_29(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_30(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_31(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_32(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_33(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_34(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_35(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_36(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_37(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_38(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_39(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_40(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_41(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_42(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_43(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_44(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_45(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_46(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_47(unsigned char *, unsigned int, int *, Elf32_Addr);
void           gadget_linux8632_48(unsigned char *, unsigned int, int *, Elf32_Addr);

#endif

