/*
** RopGadget - Release v2
** Jonathan Salwan - http://shell-storm.org - http://twitter.com/shell_storm
** 2011-03-11
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
*/

#include "ropgadget.h"

void gadget_linux8632_00(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
       if(!strncmp((const char *)data, "\xcd\x80", 2) && tab[0] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sint $0x80%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[0] = 1;
        }
}

void gadget_linux8632_01(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\xff\xd0", 2) && tab[1] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %scall *%%eax%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[1] = 1;
        }
}

void gadget_linux8632_02(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x5b\x5d\xc3", 3) && tab[2] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%ebx | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[2] = 1;
        }
}

void gadget_linux8632_03(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x59\x5b\xc9\xc3", 4) && tab[3] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%ecx | pop %%ebx | leave | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[3] = 1; 
        }
}

void gadget_linux8632_04(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x58\x5b\xc9\xc3", 4) && tab[4] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%eax | pop %%ebx | leave | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[4] = 1;
        }
}

void gadget_linux8632_05(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x58\x5b\x5e\x5f\xc3", 5) && tab[5] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%eax | pop %%ebx | pop %%esi | pop %%edi | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[5] = 1;
        }
}

void gadget_linux8632_06(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x31\xc0\xc3", 3) && tab[6] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sxor %%eax,%%eax | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[6] = 1;
        }
}

void gadget_linux8632_07(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x31\xc0\x5b\x5d\xc3", 5) && tab[7] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sxor %%eax,%%eax | pop %%ebx | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[7] = 1;
        }
}

void gadget_linux8632_08(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x31\xc0\x5b\x5e\x5f\x5d\xc3", 5) && tab[8] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sxor %%eax,%%eax | pop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[8] = 1;
        }
}

void gadget_linux8632_09(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x31\xc0\xc9\xc3", 4) && tab[9] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sxor %%eax,%%eax | leave | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[9] = 1;
        }
}

void gadget_linux8632_10(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x31\xc0\x5f\xc3", 4) && tab[10] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sxor %%eax,%%eax | pop %%edi | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[10] = 1;
        }
}

void gadget_linux8632_11(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x31\xc0\x5b\xc3", 4) && tab[11] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sxor %%eax,%%eax | pop %%ebx | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[11] = 1;
        }
}

void gadget_linux8632_12(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x40\xc3", 2) && tab[12] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sinc %%eax | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[12] = 1;
        }
}

void gadget_linux8632_13(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x40\x5f\x5e\xc3", 4) && tab[13] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sinc %%eax | pop %%edi | pop %%esi | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[13] = 1;
        }
}

void gadget_linux8632_14(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x40\x5f\xc3", 3) && tab[14] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sinc %%eax | pop %%edi | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[14] = 1;
        }
}

void gadget_linux8632_15(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x5b\x5e\x5d\xc3", 4) && tab[15] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%ebx | pop %%esi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[15] = 1;
        }
}

void gadget_linux8632_16(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x5b\x5e\x5f\x5d\xc3", 4) && tab[16] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[16] = 1;
        }
}

void gadget_linux8632_17(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xd8\x5b\x5d\xc3", 5) && tab[17] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ebx,%%eax | pop %%ebx | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[17] = 1;
        }
}

void gadget_linux8632_18(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xd0\x5b\x5e\x5f\x5d\xc3", 7) && tab[18] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%edx,%%eax | pop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[18] = 1;
        }
}

void gadget_linux8632_19(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xf8\x5b\x5e\x5f\x5d\xc3", 7) && tab[19] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%edi,%%eax | pop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[19] = 1;
        }
}

void gadget_linux8632_20(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xd8\x5b\x5e\x5f\x5d\xc3", 7) && tab[20] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ebx,%%eax | pop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[20] = 1;
        }
}

void gadget_linux8632_21(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x5d\xc3", 2) && tab[21] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[21] = 1;
        }
}

void gadget_linux8632_22(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xf0\x5b\x5e\x5f\x5d\xc3", 7) && tab[22] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%esi,%%eax | pop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[22] = 1;
        }
}

void gadget_linux8632_23(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xc8\x5b\x5e\x5f\x5d\xc3", 7) && tab[23] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ecx,%%eax | pop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[23] = 1;
        }
}

void gadget_linux8632_24(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xd8\x5b\x5e\x5d\xc3", 6) && tab[24] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ebx,%%eax | pop %%ebx | pop %%esi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[24] = 1;
        }
}

void gadget_linux8632_25(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xec\x5d\xc3", 4) && tab[25] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ebp,%%esp | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[25] = 1;
        }
}

void gadget_linux8632_26(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x0b\x83\xc4\x08\x5b\x5e\x5d\xc3", 9) && tab[26] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ecx,(%%ebx) | add $0x8,%%esp | pop %%ebx | pop %%esi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[26] = 1;
        }
}

void gadget_linux8632_27(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x0a\x83\xc4\x08\x5b\x5d\xc3", 8) && tab[27] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ecx,(%%edx) | add $0x8,%%esp | pop %%ebx | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[27] = 1;
        }
}

void gadget_linux8632_28(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x5e\x5b\x5a\xc3", 4) && tab[28] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%esi | pop %%ebx | pop %%edx | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[28] = 1;
        }
}

void gadget_linux8632_29(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x5a\x59\x5b\xc3", 4) && tab[29] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %spop %%edx | pop %%ecx | pop %%ebx | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[29] = 1;
        }
}

void gadget_linux8632_30(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x31\xc0\x89\xe5\x5d\xc3", 6) && tab[30] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sxor %%eax,%%eax | mov %%esp, %%ebp | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[30] = 1;
        }
}

void gadget_linux8632_31(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x01\x5d\xc3", 4) && tab[31] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%eax,(%%ecx) | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[31] = 1;
        }
}

void gadget_linux8632_32(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x29\xd8\x5b\x5e\x5f\x5d\xc3", 7) && tab[32] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %ssub %%ebx,%%eax | pop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[32] = 1;
        }
}

void gadget_linux8632_33(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xe8\x01\x5d\xc3", 5) && tab[33] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %ssub $0x1,%%eax | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[33] = 1;
        }
}

void gadget_linux8632_34(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\xc2\x0c", 2) && tab[34] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sret $0xc%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[34] = 1;
        }
}

void gadget_linux8632_35(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\xc2\x0b", 2) && tab[35] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sret $0xb%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[35] = 1;
        }
}

void gadget_linux8632_36(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x02\xc3", 3) && tab[36] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%eax,(%%edx) | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[36] = 1;
        }
}

void gadget_linux8632_37(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x02\x5d\xc3", 3) && tab[37] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%eax,(%%edx) | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[37] = 1;
        }
}

void gadget_linux8632_38(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xd0\x5b\x5e\x5f\x5d\xc3", 7) && tab[38] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%edx,%%eax | pop %%ebx | pop %%esi | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[38] = 1;
        }
}

void gadget_linux8632_39(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\xc7\x89\xf8\x5f\x5d\xc3", 7) && tab[39] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%eax,%%edi | mov %%edi, %%eax | pop %%edi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[39] = 1;
        }
}

void gadget_linux8632_40(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x40\x40\x40\xc3", 4) && tab[40] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sinc %%eax | inc %%eax | inc %%eax | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[40] = 1;
        }
}

void gadget_linux8632_41(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x40\x40\xc3", 3) && tab[41] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sinc %%eax | inc %%eax | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[41] = 1;
        }
}

void gadget_linux8632_42(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x01\xd8\x5b\x5d\xc3", 5) && tab[42] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %sadd %%ebx,%%eax | pop %%ebx | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[42] = 1;
        }
}

void gadget_linux8632_43(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x03\x02\x8b\x1c\x24\x89\xec\x5d\xc3", 9) && tab[43] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov (%%edx),%%eax | mov (%%esp), %%ebx | mov %%ebp,%%esp | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[43] = 1;
        }
}

void gadget_linux8632_44(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x83\xe8\x01\x5b\x5e\x5d\xc3", 7) && tab[44] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %ssub $0x1,%%eax | pop %%ebx | pop %%esi | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[44] = 1;
        }
}

void gadget_linux8632_45(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x07\x58\x5b\x5e\x5f\xc3", 7) && tab[45] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%eax,(%%edi) | pop %%eax | pop %%ebx | pop %%esi | pop %%edi | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[45] = 1;
        }
}

void gadget_linux8632_46(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x1f\x5b\x5e\x5f\xc3", 8) && tab[46] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ebx,(%%edi) | pop %%ebx | pop %%esi | pop %%edi | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[46] = 1;
        }
}

void gadget_linux8632_47(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x0a\x5d\xc3", 4) && tab[47] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%ecx,(%%edx) | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[47] = 1;
        }
}

void gadget_linux8632_48(unsigned char *data, unsigned int cpt, int *tab, Elf32_Addr offset)
{
      if(!strncmp((const char *)data, "\x89\x01\x89\xd8\x5b\x5d\xc3", 7) && tab[48] != 1 && (offset + cpt) >= pElf_Header->e_entry)
        {
          fprintf(stdout, "%s0x%.8x%s: %smov %%eax,(%%ecx) | mov %%ebx,%%eax | pop %%ebx | pop %%ebp | ret%s\n", RED, cpt + offset, ENDC, GREEN, ENDC);
          tab[48] = 1;
        }
}

