/*
** RopGadget - Release v2
** Jonathan Salwan - http://shell-storm.org - http://twitter.com/shell_storm
** 2011-03-11
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
*/

#include "ropgadget.h"

void print_info_header(void)
{
  fprintf(stdout, "%sHeader informations\n", YELLOW);
  fprintf(stdout, "============================================================%s\n", ENDC);
  fprintf(stdout, "phoff        %s0x%.8x%s\n", RED, pElf_Header->e_phoff, ENDC);
  fprintf(stdout, "shoff        %s0x%.8x%s\n", RED, pElf_Header->e_shoff, ENDC);
  fprintf(stdout, "phnum        %s0x%.8x (%d)%s\n", RED, pElf_Header->e_phnum, pElf_Header->e_phnum,ENDC);
  fprintf(stdout, "shnum        %s0x%.8x (%d)%s\n", RED, pElf_Header->e_shnum, pElf_Header->e_shnum,ENDC);
  fprintf(stdout, "phentsize    %s0x%.8x%s\n", RED, pElf_Header->e_phentsize, ENDC);
  fprintf(stdout, "shstrndx     %s0x%.8x%s\n", RED, pElf_Header->e_shstrndx, ENDC);
  fprintf(stdout, "entry        %s0x%.8x%s\n\n", RED, pElf_Header->e_entry, ENDC);
  fprintf(stdout, "LOAD vaddr   %s0x%.8x%s\n", RED, pElf32_Phdr->p_vaddr, ENDC);
  fprintf(stdout, "LOAD offset  %s0x%.8x%s\n\n", RED, pElf32_Phdr->p_offset, ENDC);
}

void search_gadgets(unsigned char *data, unsigned int size_data)
{
  unsigned int cpt = 0;
  int tab[NB_GADGET + 1] = {0};
  int i;
  p_func tab_func[] = {
                         gadget_linux8632_00, gadget_linux8632_01, gadget_linux8632_02, gadget_linux8632_03, 
                         gadget_linux8632_04, gadget_linux8632_05, gadget_linux8632_06, gadget_linux8632_07,
                         gadget_linux8632_08, gadget_linux8632_09, gadget_linux8632_10, gadget_linux8632_11, 
                         gadget_linux8632_12, gadget_linux8632_13, gadget_linux8632_14, gadget_linux8632_15,
                         gadget_linux8632_16, gadget_linux8632_17, gadget_linux8632_18, gadget_linux8632_19, 
                         gadget_linux8632_20, gadget_linux8632_21, gadget_linux8632_22, gadget_linux8632_23,
                         gadget_linux8632_24, gadget_linux8632_25, gadget_linux8632_26, gadget_linux8632_27,
                         gadget_linux8632_28, gadget_linux8632_29, gadget_linux8632_30, gadget_linux8632_31,
                         gadget_linux8632_32, gadget_linux8632_33, gadget_linux8632_34, gadget_linux8632_35,
                         gadget_linux8632_36, gadget_linux8632_37, gadget_linux8632_38, gadget_linux8632_39,
                         gadget_linux8632_40, gadget_linux8632_41, gadget_linux8632_42, gadget_linux8632_43,
                         gadget_linux8632_44, gadget_linux8632_45, gadget_linux8632_46, gadget_linux8632_47,
                         gadget_linux8632_48
                      };

  if (check_elf_format(data) == -1)
    no_elf_format();
  if (check_arch_supported() == -1)
    no_arch_supported();

  print_info_header();
  fprintf(stdout, "%sGadgets informations\n", YELLOW);
  fprintf(stdout, "============================================================%s\n", ENDC);
  while(cpt < size_data)
    {
      i = 0;
      while (i <= NB_GADGET)
        {
          if (tab[i] != 1)
            /* Linux/x86-32bits */
            if (pElf_Header->e_ident[EI_CLASS] == ELFCLASS32 && pElf_Header->e_ident[EI_OSABI] == ELFOSABI_NONE && pElf_Header->e_machine == EM_386)
              tab_func[i](data, cpt, tab, (pElf32_Phdr->p_vaddr - pElf32_Phdr->p_offset));
          i++;
        }
      cpt++;
      data++;
    }
  how_many_found(tab);
}
